/* 
 * ִ   ǻ к  ȸ '(http://hantor.ajou.ac.kr)'
 * 2002  7  ȸ ǰ.
 * : ̽¿.
 * α׷    liv@livnow.net  ֽðų  ȸ
 * Ȩ Խǿ ֽʽÿ.
 */

#include <stdio.h>
#include <string.h>
#include "data_structure.h"

#define SEARCH_BY_ENGLISH	0				//  ̸ ѱ ̸ ã 
#define SEARCH_BY_KOREAN	1				// ѱ ̸  ̸ ã 

// ȯǥ ٷµ ʿ ڷᱸ
typedef struct _convtbl_node {
	char *korean;				// ѱ ̸
	char *english;				//  ̸
} convtbl_node;

int convtbl_init();
int convtbl_add(char *korean,char *english);
int convtbl_del(char *key,int type);
int convtbl_find(char *key,int type);
convtbl_node* convtbl_get(convtbl_node *convtbl_ret,int pos);

int convtbl_db_id=-1;

/* init()
 * ȯ:	 0, н -1
 * :	ڷᱸ ʱȭѴ. ڷᱸ ϱ   ȣ Ѵ.
 */
int convtbl_init() {
	convtbl_db_id=init();
	if(convtbl_db_id==-1) {
		return -1;
	}

	return 0;
}

int convtbl_add(char *korean,char *english) {
	convtbl_node *t;
	int ret;

	if(convtbl_db_id==-1) {
		ret=convtbl_init();
		if(ret==-1) {
			return -1;
		}
	}

	t=(convtbl_node*)malloc(sizeof(convtbl_node));
	if(t==NULL) {
		return -1;
	}

	t->korean=(char*)malloc(strlen(korean)+1);
	t->english=(char*)malloc(strlen(english)+1);
	if(t->korean==NULL || t->english==NULL) {
		return -1;
	}

	strcpy(t->korean,korean);
	strcpy(t->english,english);

	add(convtbl_db_id,t,sizeof(convtbl_node));

	return 0;
}

int convtbl_del(char *key,int type) {
	convtbl_node t;
	int pos=0;
	int convtbl_datanum;
	int ret;

	if(convtbl_db_id==-1) {
		ret=convtbl_init();
		if(ret==-1) {
			return -1;
		}
	}


	convtbl_datanum=size(convtbl_db_id);
	pos=convtbl_find(key,type);
	if(pos==-1) {
		return -1;
	}
	convtbl_get(&t,pos);

	free(t.korean);
	free(t.english);

	del(convtbl_db_id,pos);

	return 0;
}

convtbl_node* convtbl_get(convtbl_node *convtbl_ret,int pos) {
	convtbl_node *t;
	int convtbl_datanum;
	int ret;

	if(convtbl_db_id==-1) {
		ret=convtbl_init();
		if(ret==-1) {
			return NULL;
		}
	}


	convtbl_datanum=size(convtbl_db_id);
	if(pos<0 || pos>convtbl_datanum) {
		return NULL;
	}

	t=get(t,convtbl_db_id,pos);

	convtbl_ret->korean=(char*)malloc(strlen(t->korean)+1);
	convtbl_ret->english=(char*)malloc(strlen(t->english)+1);
	strcpy(convtbl_ret->korean,t->korean);
	strcpy(convtbl_ret->english,t->english);

	return convtbl_ret;
}

int convtbl_find(char *key,int type) {
	convtbl_node *t;
	int convtbl_datanum;
	int pos;
	int ret;

	if(convtbl_db_id==-1) {
		ret=convtbl_init();
		if(ret==-1) {
			return -1;
		}
	}


	convtbl_datanum=size(convtbl_db_id);
	for(pos=0;pos<convtbl_datanum;pos++) {
		t=get(t,convtbl_db_id,pos);

		if(type==SEARCH_BY_KOREAN) {		// ѱ۷ ˻
			if(strncmp(t->korean,key,strlen(key))==0) {
				return pos;
			}
		} else {							//  ˻
			if(strncmp(t->english,key,strlen(key))==0) {
				return pos;
			}
		}
	}

	return -1;
}
