/* 
 * ִ   ǻ к  ȸ '(http://hantor.ajou.ac.kr)'
 * 2002  7  ȸ ǰ.
 * : ̽¿.
 * α׷    liv@livnow.net  ֽðų  ȸ
 * Ȩ Խǿ ֽʽÿ.
 */

#include <stdio.h>
#include <string.h>
#include "data_structure.h"

typedef struct _yybuf_node {
	YY_BUFFER_STATE yybuf;
} yybuf_node;

int yybuf_stack_init();
int yybuf_stack_push(YY_BUFFER_STATE yybuf);
YY_BUFFER_STATE yybuf_stack_pop();
int yybuf_stack_size();

int yybuf_stack_id=-1;

/* init()
 * ȯ:	 0, н -1
 * :	ڷᱸ ʱȭѴ. ڷᱸ ϱ   ȣ Ѵ.
 */
int yybuf_stack_init() {
	yybuf_stack_id=init();
	if(yybuf_stack_id==-1) {
		return -1;
	}

	return 0;
}

/* yybuf_stack_push(lex buffer)
 * ȯ:	 0, н -1
 * :	lex buffer  ÿ ־д.
 * 			  ߰ ,  ۾ϴ   ΰ
 * 			(lex buffer  صΰ) ο    Ѵ.
 */
int yybuf_stack_push(YY_BUFFER_STATE yybuf) {
	yybuf_node *t;
	int ret;

	if(yybuf_stack_id==-1) {
		ret=yybuf_stack_init();
		if(ret==-1) {
			return -1;
		}
	}

	t=(yybuf_node*)malloc(sizeof(yybuf_node));
	if(t==NULL) {
		return -1;
	}

	t->yybuf=yybuf;

	add(yybuf_stack_id,t,sizeof(yybuf_node));

	return 0;
}

/* yybuf_stack_pop() {{{
 * ȯ:	lex buffer,   NULL
 * :	ֱٿ  lex buffer  ÿ ´.
 */
YY_BUFFER_STATE yybuf_stack_pop() {
	yybuf_node *t;
	YY_BUFFER_STATE yybuf;
	int pos=0;
	int yybuf_datanum;
	int ret;

	if(yybuf_stack_id==-1) {
		ret=yybuf_stack_init();
		if(ret==-1) {
			return NULL;
		}
	}


	yybuf_datanum=size(yybuf_stack_id);
	pos=yybuf_datanum-1;
	t=get(t,yybuf_stack_id,pos);
	if(t==NULL) {
		return NULL;
	}

	yybuf=t->yybuf;

	del(yybuf_stack_id,pos);

	return yybuf;
}
// }}}

/* yybuf_stack_size()
 * ȯ:	 ũ, н -1
 * :	lex buffer  ȿ   ۰ Ǿ ִ ȯѴ.
 */
int yybuf_stack_size() {
	int ret;

	if(yybuf_stack_id==-1) {
		ret=yybuf_stack_init();
		if(ret==-1) {
			return -1;
		}
	}

	return size(yybuf_stack_id);
}
