/* 
 * ִ   ǻ к  ȸ '(http://hantor.ajou.ac.kr)'
 * 2002  7  ȸ ǰ.
 * : ̽¿.
 * α׷    liv@livnow.net  ֽðų  ȸ
 * Ȩ Խǿ ֽʽÿ.
 */

#include <stdio.h>
#include <string.h>
#include "data_structure.h"

// include ̺ ٷµ ̴ ڷᱸ.
typedef struct _includetbl_node {
	char *name;
} includetbl_node;

int includetbl_init();
int includetbl_add(char *name);
int includetbl_del(char *key);
int includetbl_find(char *key);
includetbl_node* includetbl_get(includetbl_node *includetbl_ret,int pos);

int includetbl_db_id=-1;

/* init()
 * ȯ:	 0, н -1
 * :	ڷᱸ ʱȭѴ. ڷᱸ ϱ   ȣ Ѵ.
 */
int includetbl_init() {
	includetbl_db_id=init();
	if(includetbl_db_id==-1) {
		return -1;
	}

	return 0;
}

/* includetbl_add(ϸ)
 * ȯ:	 0, н -1
 * :	include ̺ ش ϸ Ѵ.
 * 			ϵ ϸ  includetbl_find  ã  ְ
 * 			includetbl_get     includetbl_del 
 * 			  ִ.
 */
int includetbl_add(char *name) {
	includetbl_node *t;
	int ret;

	if(includetbl_db_id==-1) {
		ret=includetbl_init();
		if(ret==-1) {
			return -1;
		}
	}

	t=(includetbl_node*)malloc(sizeof(includetbl_node));
	if(t==NULL) {
		return -1;
	}

	t->name=(char*)malloc(strlen(name)+1);
	if(t->name==NULL) {
		return -1;
	}

	strcpy(t->name,name);

	add(includetbl_db_id,t,sizeof(includetbl_node));

	return 0;
}

/* includetbl_del(ϸ)
 * ȯ:	 0, н -1
 * :	include ̺ ش ϸ Ѵ.
 */
int includetbl_del(char *key) {
	includetbl_node t;
	int pos=0;
	int includetbl_datanum;
	int ret;

	if(includetbl_db_id==-1) {
		ret=includetbl_init();
		if(ret==-1) {
			return -1;
		}
	}


	includetbl_datanum=size(includetbl_db_id);
	pos=includetbl_find(key);
	if(pos==-1) {
		return -1;
	}
	includetbl_get(&t,pos);

	free(t.name);

	del(includetbl_db_id,pos);

	return 0;
}

/* includetbl_get(˻ ڷᰡ  includetbl_node, ġ)
 * ȯ:	˻ ڷ, ã  NULL
 * :	ش ġ ڷḦ ȯѴ.
 */
includetbl_node* includetbl_get(includetbl_node *includetbl_ret,int pos) {
	includetbl_node *t;
	int includetbl_datanum;
	int ret;

	if(includetbl_db_id==-1) {
		ret=includetbl_init();
		if(ret==-1) {
			return NULL;
		}
	}


	includetbl_datanum=size(includetbl_db_id);
	if(pos<0 || pos>includetbl_datanum) {
		return NULL;
	}

	t=get(t,includetbl_db_id,pos);

	includetbl_ret->name=(char*)malloc(strlen(t->name)+1);
	strcpy(includetbl_ret->name,t->name);

	return includetbl_ret;
}

/* includetbl_find(ϸ) {{{
 * ȯ:	ã ġ, ã  -1
 * :	include ̺ ش ϸ ˻Ѵ.
 * 			ش ϸ ϸ  ġ,
 * 			ã ٸ -1 ȯѴ.
 */
int includetbl_find(char *key) {
	includetbl_node *t;
	int includetbl_datanum;
	int pos;
	int ret;

	if(includetbl_db_id==-1) {
		ret=includetbl_init();
		if(ret==-1) {
			return -1;
		}
	}


	includetbl_datanum=size(includetbl_db_id);
	for(pos=0;pos<includetbl_datanum;pos++) {
		t=get(t,includetbl_db_id,pos);

		if(strncmp(t->name,key,strlen(key))==0) {
			return pos;
		}
	}

	return -1;
}
// }}}
